// ball.java
// manages ball motion for polypong
package pong;

import java.rmi.*;
import pong.*;

public class ball implements Runnable
{ double x,y, ox,oy; // ball location
  double vx,vy;
  Thread t;
  pongRMI rec;
  int slt =0;

  public ball(int pos, int ang, pongRMI reciever)
  { x = 99*Math.sin(pos*Math.PI/180);
    y = 99*Math.cos(pos*Math.PI/180);
    vx = -10 * Math.sin(ang*Math.PI/180);
    vy = -10 * Math.cos(ang*Math.PI/180);
    rec = reciever;
    // find slot
    try
    { while ( (rec.host.playing[slt]!=null) && (slt <8) &&
          (rec.host.playing[slt].getIDint() != rec.host.local[0].getIDint()) )
      { slt++; }
    }
    catch (RemoteException e) {}
    t = new Thread (this);
    t.start();
  }

  public void run()
  { double r=0, a;
    int paddle;
    int i, bang, ad;
    while (r <= 100)
    { a = Math.atan2(x,y);
      r = Math.sqrt(x*x+y*y);
      ad = (int)(a*180/Math.PI);

      // echo ball position to other players
      for (i = 0; i<8; i++)
      {if (rec.host.playing[i] != null) 
       {try
        { rec.host.playing[i].ballMove((int)r,ad-360*slt/rec.host.nplay); 
          // show send attempts
          //System.out.print("moving ball on ");
          //System.out.println(rec.host.playing[i].getIDint() );
        }
        catch (RemoteException e){ System.out.println("ball move failure"+e); }
       }
      }
      // check for paddle hit
      if (r > 100) // reached edge of field
      { paddle = rec.host.local[0].paddle;
        paddle = (paddle+180)%360 -180; // -180<paddle<180
        if ( ((ad+rec.host.pmax/5)>paddle) && ((ad-rec.host.pmax/5)<paddle) )
        { //bang = (paddle-ad) * 35 / (rec.host.pmax/5);
          //bang = Math.round(Math.atan(paddle-ad)*rec.host.nplay);
	  bang = (paddle-ad)*rec.host.nplay;
          System.out.println("re-serving");
          
          for (i = 0; i<8; i++)
          {if (rec.host.playing[i] != null) 
           {try  // serv with angle relitive to playing[0]
            { rec.host.playing[i].serve(ad-360*slt/rec.host.nplay ,bang); }
            catch (RemoteException e){}
           }
          }
          System.out.println("re-served");
        }
        else // missed
        { for (i = 1; i<8; i++)
          {if (rec.host.playing[i] != null) 
           {try
            { rec.host.playing[i].chat("Missed"); }
            catch (RemoteException e){}
           }
          }
          try
          { rec.host.lastserv.goserv(); }
          catch (RemoteException e){}
          System.out.print("missed at ");
          System.out.print(ad);
          System.out.print(":");
          System.out.println(paddle);
        }
      }
      // update for next timeslice
      ox = x;      x += vx;
      oy = y;      y += vy;
      try
      { t.sleep (100); }
      catch (Exception e){}
    }
  }
}
