package pong;

import java.rmi.*;
import java.rmi.server.*;
import java.awt.Color;
import pong.*;

public class pongRMI implements pongRMIInterface
{ //
  public int paddle; // position of paddle in sector
  public String amsg = "";
  polypong host;
  public int ID;
  
  // constructor
  public pongRMI(polypong ahost) throws RemoteException
  { host = ahost;
    paddle = 0; // angle +/- degrees from center of sector
    ID = host.IDint;
    // export this
    UnicastRemoteObject.exportObject(this);
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  public pongRMIInterface[] firstconnect() throws RemoteException
  { // return handles to remote interface
    return (host.remote);
  }

  public pongRMIInterface connect(pongRMIInterface yourhost) throws RemoteException
  { int indx=1;
    // accept interface, create a fresh interface for caller
    while ((host.remote[indx] != null)&&(indx <8))    { indx++; }
    if (indx<8) // slot found
    { host.remote[indx] = yourhost;
      host.local[indx] = new pongRMI(host);
      return ((pongRMIInterface)host.local[indx]);
    }
    //System.runFinalization();
    return (null);
  }

  public int disconnect() throws RemoteException
  { int indx=1;
    // if (host.nplay != 0) {return (0); }
    for (indx = 0;
          (host.remote[indx] != null) && 
          (this.getIDint() != host.remote[indx].getIDint()) &&
          (indx <8);
        indx++ );

    if (indx <8)
    { host.local[indx] = null;
      host.remote[indx] = null;
    }
    return (1);
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  // declares a round is about to begin, get list of players to syncronize
  public pongRMIInterface[] startRound() throws RemoteException
  { // host.nplay = -1; // use as a state flag
    return (host.remote);
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  public int serve(pongRMIInterface players[]) throws RemoteException
  { int indx, cnt = 0, i,j;
    // count players
    for (indx = 0; indx<8; indx++)
    { if (players[indx] != null) { cnt++; }  }
    host.nplay = cnt;
    host.playing = players;
    host.pmax = 180/host.nplay;
    // map players to this hosts list
    for (i=0; i<8; i++)
    { for (j = 0; j<8; j++)
      { if ( (players[i] !=null) && (host.local[j]!=null) &&
            (players[i].getIDint() == host.remote[j].getIDint() ) )
        { host.playing[i] = host.remote[j]; }
      }
      /*if (players[i] !=null)
      { System.out.print("players[");
        System.out.print(i);
        System.out.print("] is #");
        System.out.println(players[i].getIDint() );
      }*/
    }
    //serve(paddle, angle);
    host.clear_miss();
    return (1);
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  public int serve(int paddle, int angle) throws RemoteException
  { int indx = 0, i, pang, bang, svs;
    // find our slot
    if (host.playing[0] == null)
    { return(-3); }
    angle %= 360;
    System.out.println("being served...");
    while (host.playing[indx].getIDint() != this.getIDint())
    { indx++; }
    
    // is ball headed for this sector?  convert paddle to this sectors view
    pang = (paddle+(360*indx/host.nplay)) %360;

    bang = (pang + 180 + angle*2) % 360;
    bang = ((bang+180)%360)-180; // -180<bang<180
    
System.out.print("pang:");
System.out.print(pang);
System.out.print("  angle:");
System.out.println(angle);
    svs = (angle/(360/host.nplay));
    
    host.lastserv = host.playing[svs];
    if ((-host.pmax < bang) && (host.pmax > bang)) //  we handle
    { new ball(pang, pang-angle, host.local[0]);
      System.out.println("handling ball");
      return (2); 
    }
    else
    { host.mayserv = false; 
      host.serve.setEnabled(false);
    }
    return (1);
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  // transilate ball into local coordinates for display
  public int ballMove(int r, int a) throws RemoteException
  { int indx = 0, bang;
    while (host.playing[indx].getIDint() != this.getIDint()) { indx++; } // find this slot
    bang = a+(360*indx/host.nplay);
    host.drawball(Color.green);
    host.ballr = r;   host.ballang = bang;
    host.drawball(Color.white);
/*    System.out.print("slot=");
    System.out.print(indx);
    System.out.print("  ball moved: r=");
    System.out.println(r); */
    return (1);
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

  public int paddle(int angle) throws RemoteException
  { int indx = 0, pang;
    paddle = angle;
    // find this slot
    /*while ( (host.playing[indx]!=null) && 
        ( host.playing[indx].getIDint() != this.getIDint() ) )
        { indx++; }
    pang = angle;//+(360*indx/host.nplay);
    host.drawpaddle(paddle, Color.green);
    paddle = pang;
    host.drawpaddle(paddle, Color.blue);*/
    return(1);
  }

  public int getpaddle() throws RemoteException
  { return (paddle); }

  public int goserv() throws RemoteException
  { host.mayserv = true;
    host.serve.setEnabled(true);
    return (1);
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// auxillary communication

  public int chat(String msg) throws RemoteException
  { amsg = msg; // display update will grab and display
    return (1);
  }

  public int getIDint() throws RemoteException
  { return (ID); }
}
  
