package pong;

import java.awt.*;
import java.awt.event.*;
import java.rmi.*;
import java.rmi.server.*;
//import *;
import pong.*;
//import phanely.*;

public class polypong implements MouseMotionListener, ActionListener
{
  Frame f;
  Canvas field;
  //Graphics g;
  public Button connect, start, serve, help, exit;
  pongRMI[] local; // hosting other players
  pongRMIInterface[] remote; // client to other players
  public pongRMIInterface playing[]; // who is playing this round? in order
  Panel messages;
  Label msg[];
  TextField intext;
  String intextval = "";
  int lastMx=1, lastMy=1;

// your playfield stats
  public String ID;
  public int IDint;
  public pongRMIInterface lastserv;
  boolean mayserv = false;
  int ballr, ballang;  // position of ball
  int nplay = 2; // how many are playing current round
  int pmax = 90;

// initialization ******************************************
  public polypong()
  { ID = "";
    // a usually unique ID
    IDint = (int)System.currentTimeMillis();

    init_rmi();
    init_gui();
    init_events();

    //nplay = 2;
  }

  void init_rmi()
  { int i;
    try
    { local = new pongRMI[8];
      remote = new pongRMIInterface[8];
      playing = new pongRMIInterface[8];
      local[0] = new pongRMI(this);
      remote[0] = (pongRMIInterface)local[0];
      playing[0] = (pongRMIInterface)null;
      for (i = 1; i<8; i++)
      { local[i] = (pongRMI)null;
        remote[i] = (pongRMIInterface)null;
        playing[i] = (pongRMIInterface)null;
      }
    }
    catch (RemoteException e)
    { System.out.println ("RMI Init " + e); };
  }

  void init_gui()
  { int i;

    // play field
    field = new Canvas();
    field.setSize(600,300);

    // control pannel
    Panel p = new Panel(new GridLayout(5,1));
    connect = new Button("Connect");
    p.add(connect);
    start = new Button("Host Login");
    p.add(start);
    serve = new Button("Serve");
    p.add(serve);
    serve.setEnabled(false);
    help = new Button("help");
    p.add(help);
    exit = new Button("exit");
    p.add(exit);

    // message window
    messages = new Panel(new GridLayout(9,1));
    msg = new Label[8];
    for (i = 1; i<8; i++)
    { msg[i] =  new Label("*",Label.LEFT);
      msg[i].setSize(60,1);
      messages.add(msg[i]);
    }

    // message input window
    intext = new TextField(60);
    messages.add(intext);
        
    // program window
    f = new Frame();
    //f.add("North",intext);
    f.setTitle("PolyPong");
    f.add("South",messages);
    f.add("East", p);
    f.add(field);
    f.pack();
    f.show();
  }

  void init_events()
  { connect.addActionListener(this);
    connect.setActionCommand("conn");
    start.addActionListener(this);
    start.setActionCommand("start");
    serve.addActionListener(this);
    serve.setActionCommand("serve");
    help.addActionListener(this);
    help.setActionCommand("help");
    exit.addActionListener(this);
    exit.setActionCommand("exit");
    intext.addActionListener(this);
    //intext.setActionCommand("intext");

    field.addMouseMotionListener(this);
    f.addMouseMotionListener(this);
  }

// event handling **********************************

  public void actionPerformed(ActionEvent e)
  { String cmd = e.getActionCommand();
    // Which button?
    if ("conn".equals(cmd)) { ev_connect(); }
    else if ("start".equals(cmd))   { ev_start(); }
    else if ("serve".equals(cmd))   { ev_serve(); }
    else if ("help".equals(cmd))    { ev_help(); }
    else if ("exit".equals(cmd))    { ev_exit(); }
    else { ev_intext(e.paramString()); } // must be intext
  }

  void ev_connect()
  { // get host ID from intext field
    String host = intextval;
    pongRMIInterface listing[] = new pongRMIInterface[8];
    int i, j = 1;
    for (i = 0; i<8; i++)
    { listing[i] = null; } // to keep java happy about initialization
    // connect to server
    try
    { pongRMIInterface first =
           (pongRMIInterface)Naming.lookup ("//"+host+"/polypong"); 
      listing = first.firstconnect();
      if (listing == null)
      { System.out.println ("connection failed, no player list");
      }
    
      for ( i = 0;  i<8; i++) // iterate through listing
      { 
        // try to connect
        if (listing[i] != null)
        { // find empty slot in local arrays
          for (j=1; (j<8) && (local[j]!=null); j++);
          if (j>=8)
          { throw (new Exception("out of space")); }

          local[j] = new pongRMI(this);
          System.out.println ("Connecting to player");
          try
          { remote[j] = listing[i].connect(local[j]);
            if (remote[j] == null)
            { local[j] = null;
              System.out.println ("bad entry in listing");
            }
            else
            { System.out.println ("Connected to player"); 
              remote[j].chat("hello");
            }
          }
          catch (RemoteException e)
          { local[j] = null;
            System.out.println ("connect problem "+e);
          }
        }
      } // for each host
    }
    catch (Exception e)
    { //new alert("invalid host" +e);
      System.out.println ("invalid host" +e);
    }
    //System.runFinalization();
  } // connect to a game

  void ev_start()
  { System.out.println ("starting login");
    // make our first rmi object available for first connect
    if (System.getSecurityManager() == null)
    { System.setSecurityManager (new RMISecurityManager());
      System.out.println ("starting security manager");
    }
    try
    { Naming.rebind ("polypong", local[0]);
      System.out.println ("Server is ready.");
      mayserv = true; // allows multiple pending serves
      serve.setEnabled(true);
    }
    catch (Exception e)
    { System.out.println ("Server failed: " + e);
      //if (e.getClass().getName().equals("java.security.AccessControlException"))
      //{ System.out.println(((java.security.AccessControlException)e).getPermission()); }
    }
    //System.runFinalization();
  }

  void ev_serve()
  { // start new round
    pongRMIInterface listing[]= null, tmp_playing[], cpt_playing[];
    boolean inlist[] = new boolean[8];
    int i, j, k;
    tmp_playing = new pongRMIInterface[8];
    cpt_playing = new pongRMIInterface[8];

    clear_miss();
    // copy list of players for calculations
    for (i = 0; i <8; i++)
    { tmp_playing[i] = remote[i];
    }
    System.out.println ("searching servlist");
    // figure who is connected to all
    for (i = 1; i <8; i++)
    {if (tmp_playing[i] != null) // if not already eliminated
     {System.out.println ("searching servlist...");
      try
      { listing = tmp_playing[i].startRound();
        System.out.println ("round start signaled");
        // map listing[] entries to tmp_playing or remove this host 
        // from tmp_playing
        for (j = 0; j<8; j++)
        { inlist[j] = false; } // assume they are not connected...
        // foreach listing[]{find and mark present}
        for (j = 0; j<8; j++)
        { for(k=0; k<8; k++)
          { // if player k matches slot j...
            if ( (listing[k] != null) && (remote[j] != null) &&
               (remote[j].getIDint() == listing[k].getIDint()) )
            { inlist[j] = true; } // they are here
          }
        }
        // clear those not connected round, server always plays
        if (!inlist[0])
        // ignore this players connects, they aren't playing
        { tmp_playing[i] = null;
          System.out.println ("ignoring player...");
        }
        /*else
        { for (j = 1; j<8; j++)
          { if (inlist[j] == false)
            { tmp_playing[j] = null; }
            System.out.print ("clearing incomplete player ");
            System.out.println(j);
          }
        }*/ // only for testing
      } // try to reach player
      // couldn't connect, he doesn't play this round
      catch (RemoteException e)
      { tmp_playing[i] = null;
        System.out.println ("serv miss " + e);
      }
     }
    }
    // compact list
    j = 0;
    for (i = 0; i<8; i++)
    { if (tmp_playing[i] != null)
      { cpt_playing[j] = tmp_playing[i];
        j++;
        System.out.print("playing ");  System.out.println(i);
      }
    }
    System.out.println ("serving");
    // serve to everyone
    // start round
    for (i = 0; i <8; i++)
    { if (cpt_playing[i] != null)
      { try
        { System.out.println ("serving player");
          cpt_playing[i].serve(cpt_playing);
          cpt_playing[i].chat("serving");
        }
        catch (RemoteException e)
        { System.out.println ("serv miss 2 " + e);}
      }
    }
    // actual serve
    for (i = 0; i <8; i++)
    { if (cpt_playing[i] != null)
      { try
        { cpt_playing[i].serve(3, 0); }
        catch (RemoteException e)
        { System.out.println ("serv miss 3 " + e);}
      }
    }
  }

  void ev_help()
  { try {new viewfile("pong.txt", "PolyPong Help");}
    catch (Exception e){}
  }

  void ev_exit()
  { int i;
    // disconect from everybody
    for (i=0; i<8; i++)
    { if (remote[i] != null)
      { try { remote[i].disconnect(); }
        catch (RemoteException e){}
      }
    }
    System.exit(0);
  }

  void ev_intext(String p)
  { int i;
    intextval = intext.getText();
    for (i = 1; i<8; i++)
    { if (remote[i]!=null)
      { try{ remote[i].chat(intextval); }
        catch (RemoteException e){}
      }
    }
  }

  public void mouseDragged(MouseEvent e)
  { mouseMoved (e); }

  public  void mouseMoved(MouseEvent e)
  { double angle;
    int i;
    drawfield();
    // find paddle angle
    angle = Math.atan2(150-e.getY(), (e.getX()-300)/2);
    if (local[0] != null)
    { local[0].paddle = (int)(angle*180/Math.PI);
      local[0].paddle %= 360;
      local[0].paddle += 90;
    //if (local[0].paddle >= pmax) { local[0].paddle = pmax-1;}
    //if (local[0].paddle <= pmax) { local[0].paddle = 1-pmax;}
      for (i=0 ; i<8; i++)
      { if (playing[i]!=null)
        { try
          {drawpaddle(playing[i].getpaddle(), Color.black); }
          catch (RemoteException e1) {}
        }
        if (remote[i]!=null)
        { try { remote[i].paddle(local[0].paddle); }
          catch (RemoteException e1){}
        }
      }
    }
    drawball(Color.white);
    lastMx = e.getX();
    lastMy = e.getY();
  }

// drawing methods for playfield

  void drawfield()
  { Graphics g = field.getGraphics();
    int i, ang, x,y;
    g.setColor(Color.green);
    g.fillRoundRect(0,0,600,300, 25,25);
    g.setColor(Color.black);
    g.drawOval(25,25,550,250);
    // draw sector posts
    g.setColor(Color.blue);
    for ( i = 1; i<=2*nplay; i+=2)
    { ang = -90 + i*180/nplay;
      x = 300 + (int)(275*Math.cos(ang*Math.PI/180));
      y = 150 - (int)(125*Math.sin(ang*Math.PI/180));
      g.drawLine(x,y,x,y-50);
    }
  }

  void drawpaddle(int paddle, Color C)
  { Graphics g = field.getGraphics();
    g.setColor(C);
    g.drawArc(10,10,580,280, 270+paddle-pmax/5, 2*pmax/5);
    drawchat();
  }

  void drawball( Color C)
  { int bx,by;
    bx = 300 - (int)(2.9*ballr*Math.sin(Math.PI*ballang/180));
    by = 150 + (int)(1.4*ballr*Math.cos(Math.PI*ballang/180));
    Graphics g = field.getGraphics();
    g.setColor(C);
    g.fillOval (bx-5, by-5,11,11);
    drawchat();
  }

  void drawchat()
  { int i;
    for (i = 1; i<8; i++)
    { if (local[i] != null)
      { msg[i].setText(">"+local[i].amsg); }
      else
      { msg[i].setText("*"); }
    }
  }

  void clear_miss()
  { int i;
    for (i = 0; i<8; i++)
    { if ((msg[i] !=null) && (">Missed".equals(msg[i].getText()) ) )
      { msg[i].setText(">"); }
    }
  }

// main **********************************
  public static void main (String argv[])
  { polypong g = new polypong();
    g.drawfield();
  } 
}
